﻿using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfRadialMenu.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace Grid_popupRadialMenu
{
    public partial class MainPage : ContentPage
    {
        //StackLayout radial;
        RelativeLayout relativeLayout;
        ViewModel view;
        SfRadialMenu radialMenu;
        private bool isradialDisplayed = false;
        private string currentColumnName;
        SfDataGrid dataGrid;
        public MainPage()
        {
            InitializeComponent();
            dataGrid = new SfDataGrid();
            view = new ViewModel();
            dataGrid.ItemsSource = view.OrdersInfo;
            this.dataGrid.GridLoaded += DataGrid_GridLoaded;
            this.dataGrid.GridLongPressed += DataGrid_GridLongPressed1;
            dataGrid.GridTapped += DataGrid_GridTapped;

           

            relativeLayout = new RelativeLayout();

            relativeLayout.Children.Add(dataGrid, Constraint.RelativeToParent((Parent) => { return Parent.X; }), Constraint.RelativeToParent((Parent) => { return Parent.Y * 0.15; }),
                Constraint.RelativeToParent((Parent) => { return Parent.Width; }), Constraint.RelativeToParent((Parent) => { return Parent.Height * 0.8; }));
            this.BindingContext = view;
            this.Content = relativeLayout;
        }

        private void DataGrid_GridLoaded(object sender, GridLoadedEventArgs e)
        {
            CreateRadialMenu();
        }

        private void DataGrid_GridLongPressed1(object sender, GridLongPressedEventArgs e)
        {
            if (!isradialDisplayed)
            {
                currentColumnName = dataGrid.Columns[e.RowColumnIndex.ColumnIndex].MappingName;
                var point = dataGrid.RowColumnIndexToPoint(e.RowColumnIndex);

                relativeLayout.Children.Add(radialMenu, Constraint.Constant(point.X), Constraint.Constant(point.Y));
                isradialDisplayed = true;
            }
            else
            {
                relativeLayout.Children.Remove(radialMenu);
                isradialDisplayed = false;
            }
        }

        private void DataGrid_GridTapped(object sender, GridTappedEventArgs e)
        {
            relativeLayout.Children.Remove(radialMenu);
            isradialDisplayed = false;
        }

        public void CreateRadialMenu()
        {
            radialMenu = new SfRadialMenu();
            
            radialMenu.HeightRequest = 250;
            radialMenu.WidthRequest = 180;
            radialMenu.CenterButtonText = "\uE713";
            radialMenu.CenterButtonBackText = "\uE72B";
            radialMenu.CenterButtonFontFamily = "Segoe MDL2 Assets.ttf";
            radialMenu.CenterButtonBackFontFamily = "Segoe MDL2 Assets.ttf";
            radialMenu.CenterButtonRadius = 32;
            radialMenu.CenterButtonBorderColor = Color.White;

            //Adding RadialMenu items
            string[] layer = new string[] { "\uE701", "\uE702", "\uEA8F", "\uE706", "\uEBAA", "\uE7E8" };
            string[] wifi = new string[] { "\uEC3B", "\uEC3A", "\uEC39", "\uEC38" };
            string[] battery = new string[] { "\uEBB8", "\uEBBC", "\uEBC0" };
            string[] brightness = new string[] { "\uEC8A", "\uEC8A", "\uE706" };
            string[] profile = new string[] { "\uE7ED", "\uE877", "\uEA8F" };
            string[] power = new string[] { "\uE708", "\uE777", "\uE7E8" };

            //Adding radialMenu main menu items
            for (int i = 0; i < 6; i++)
            {
                SfRadialMenuItem mainMenuItems = new SfRadialMenuItem();
                mainMenuItems.IconFontSize = 20;
                mainMenuItems.FontIconText = layer[i];
                mainMenuItems.ItemHeight = 30;
                mainMenuItems.ItemWidth = 40;
                mainMenuItems.TextColor = Color.White;
                mainMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items.Add(mainMenuItems);
            }

            // Adding wifi submenu items
            for (int i = 0; i < 4; i++)
            {
                SfRadialMenuItem wifiSubMenuItems = new SfRadialMenuItem();
                wifiSubMenuItems.IconFontSize = 20;
                wifiSubMenuItems.FontIconText = wifi[i];
                wifiSubMenuItems.ItemHeight = 30;
                wifiSubMenuItems.ItemWidth = 40;
                wifiSubMenuItems.TextColor = Color.White;
                wifiSubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[0].Items.Add(wifiSubMenuItems);
            }

            //Adding bluetooth submenu items
            for (int i = 0; i < 4; i++)
            {
                SfRadialMenuItem bluetoothSubMenuItems = new SfRadialMenuItem();
                bluetoothSubMenuItems.IconFontSize = 20;
                bluetoothSubMenuItems.FontIconText = wifi[i];
                bluetoothSubMenuItems.ItemHeight = 30;
                bluetoothSubMenuItems.ItemWidth = 40;
                bluetoothSubMenuItems.TextColor = Color.White;
                bluetoothSubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[1].Items.Add(bluetoothSubMenuItems);
            }

            //Adding profile submenu items
            for (int i = 0; i < 3; i++)
            {
                SfRadialMenuItem profileSubMenuItems = new SfRadialMenuItem();
                profileSubMenuItems.IconFontSize = 20;
                profileSubMenuItems.FontIconText = profile[i];
                profileSubMenuItems.ItemHeight = 30;
                profileSubMenuItems.ItemWidth = 40;
                profileSubMenuItems.TextColor = Color.White;
                profileSubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[2].Items.Add(profileSubMenuItems);
            }

            //Adding brightness submenu items
            for (int i = 0; i < 3; i++)
            {
                SfRadialMenuItem brightnessSubMenuItems = new SfRadialMenuItem();
                brightnessSubMenuItems.IconFontSize = 20;
                brightnessSubMenuItems.FontIconText = brightness[i];
                brightnessSubMenuItems.ItemHeight = 30;
                brightnessSubMenuItems.ItemWidth = 40;
                brightnessSubMenuItems.TextColor = Color.White;
                brightnessSubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[3].Items.Add(brightnessSubMenuItems);
            }

            //Adding battery submenu items
            for (int i = 0; i < 3; i++)
            {
                SfRadialMenuItem batterySubMenuItems = new SfRadialMenuItem();
                batterySubMenuItems.IconFontSize = 20;
                batterySubMenuItems.FontIconText = battery[i];
                batterySubMenuItems.ItemHeight = 30;
                batterySubMenuItems.ItemWidth = 40;
                batterySubMenuItems.TextColor = Color.White;
                batterySubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[4].Items.Add(batterySubMenuItems);
            }

            //Adding power submenu items
            for (int i = 0; i < 3; i++)
            {
                SfRadialMenuItem powerSubMenuItems = new SfRadialMenuItem();
                powerSubMenuItems.IconFontSize = 20;
                powerSubMenuItems.FontIconText = power[i];
                powerSubMenuItems.ItemHeight = 30;
                powerSubMenuItems.ItemWidth = 40;
                powerSubMenuItems.TextColor = Color.White;
                powerSubMenuItems.IconFontFamily = "Segoe MDL2 Assets.ttf";
                radialMenu.Items[5].Items.Add(powerSubMenuItems);
            }

        }
    }
}